<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" dir="ltr" lang="ru-RU">
<head profile="http://gmpg.org/xfn/11">
<meta http-equiv="Content-Type" content="text/html; charset=UTF-8" />
<title>OGame cron manager</title>
<link rel="stylesheet" href="style.css" type="text/css" media="screen" />
</head>
<body>
<?php

// подключение либов
$mylib_dir = dirname(__FILE__) . '/';
require_once $mylib_dir . 's_http.php';
require_once $mylib_dir . 'searcher.php';
require_once $mylib_dir . 'settings.php';
require_once $mylib_dir . 'cm.php';

//получение пользовательских данных
$st = new settings('auth.txt');
if (empty($st->S)) {
    echo "Для работы надо указать настройки подключения: откройте <a href=\"setup.php\">страницу установки</a>, заполните необходимые данные.";
    die;
}

// статические данные о игроке
$ud = $st->S;

// настройки
$crontime = $ud['time']['crontime']; //периодичность сканирования в минутах (частота 1-3 минуты)
$scanMin =  $ud['time']['scanmin']; // >= 10 мин - это диапазан для выбора следующего время сканирования, когда все тихо
$scanMax =  $ud['time']['scanmax']; // <= 25 мин
$scanBattleMin = $ud['time']['scanBattleMin']; //  -- 2 - это диапазон сканирования во время угрозы
$scanBattleMax = $ud['time']['scanBattleMax']; //  -- 5
$sensedelta = $ud['time']['sensedelta']; //чуствительность по краям - пол минуты
$noReturnTime = $ud['time']['noReturnTime']; //интервал времени, после которого возвращаться опасно - 
$tickerMethod = $ud['time']['tickerMethod']; //метод вызова сканирования

$attacker = array(
    'descr' => array('Чужой флот', '1 / 16 Флоты', '2 / 16 Флоты', '3 / 16 Флоты', '4 / 16 Флоты', '5 / 16 Флоты', 
        '6 / 16 Флоты', '7 / 16 Флоты', '8 / 16 Флоты', '9 / 16 Флоты', '10 / 16 Флоты', '11 / 16 Флоты', '12 / 16 Флоты',
        '13 / 16 Флоты', '14 / 16 Флоты', '15 / 16 Флоты', '16 / 16 Флоты'),
    'missions' => array('Атака', 'Совместная атака'),
);

/*
$attacker = array(
    'descr' => array('Собственный флот'), 'missions' => array('Транспорт', 'Оставить'),
);
*/

//подключение, авторизация, сбор информации
$CM = new fleetCommander($ud, !empty($_GET['auto']));

//режим крона (при этом режим охраны должен быть включен)
if (isset($_GET['auto'])) {

    if (!$CM->ready ) {
        if ($CM->oas['guardmode']) {
            if (($CM->ud['time']['tickerMethod'] != 'localjs' && time() >= $CM->oas['nextscan'])
                || $CM->ud['time']['tickerMethod'] == 'localjs')
                $CM->logReport('Error', 'Can`t do auth');
            if ($CM->ud['time']['tickerMethod'] != 'localjs' && time() < $CM->oas['nextscan'])
                echo "Time for next check is - " . ($CM->oas['nextscan'] - time()) . ' s.';
        }
        //сохранение установок
        $st = new settings();
        $st->S = $CM->oas;
        $st->store();
        exit;
    }

    $CM->logReport('Cron tick', "Ogame saver cron tick. Treat status: \n" . $CM->oas['treat']);
    
    //Проверка угрозы атаки – если нет угрозы – очистка признака угрозы, а также возврат флотов, запущенных из за поднятой тревоги
    if (!$CM->isAlert && $CM->oas['treat']) {
        $CM ->setOGV('treat', 0);
    }

    /* получение данных о маршрутах */
    $routs = $CM->getRouts();
    echo "\n********************ANALYS***************<pre>";
    $CM ->setOGV('routs', $routs);
    print_r($routs);
    
    $attacks = $CM->oas['attacks']; //список атак найденных в предыдущем цикле
    echo "</pre>\nLast CYCLE attacks:<pre>";
    print_r($attacks);
    echo "</pre>";
    
    $currentAttacks = array(); //список атак выявленных за данный осмотр (цикл)
    
    //включена тревога - нужно провести анализ ситуации
    if ($CM->isAlert) {
        $CM ->setOGV('treat', 1);
        $timeOutMin = 10000000;
        //вытаскиваем список сохраненных в бд атак от прошлого просмотра
        //анализ маршрутов - выявление атак
        foreach ($routs as $rout) 
            if (in_array($rout['descr'], $attacker['descr']) && in_array($rout['mission'], $attacker['missions'])
                && !empty($CM->ud['planets'][$rout['toWherePlanet']])
                    ) {
                $timeOut = $rout['aTime'] - $CM->currentTime;
                $timeOutMin = min($timeOut, $timeOutMin);
                echo "\nAttack detection from {$rout['fromWhere']} to {$rout['descr']}, {$rout['toWherePlanet']} in $timeOut sec ";
                //фиксируем код атакующего флота
                $currentAttacks[$rout['id']] = $rout;
                //обнаружена новая атака
                if (empty($attacks[$rout['id']])) {
                    //отправка оповещения
                    $CM->mailReport('New attack detected !',
                            'Your planet ' . $rout['toWherePlanet'] . ' will be attacked in ' 
                                . floor($timeOut / 60) . ' mins at ' .  date('H:i:s', $timeOut + time()). '. '
                            );
                    //сообщение атакующему (выбираем из подготовленного списка сообщений) - типа я тя вижу 
                    $messNo = rand(0, count($CM->messBase) - 1);
//                    $CM->mail($rout['fromWhere'], $CM->messBase[$messNo]['subj'], $CM->messBase[$messNo]['text']);
                }
                //если времени до атаки менее макс цикла сканирования в боев режиме, то нужно отправлять беженцев, если отправка беженцев разрешена
                $planetName = $CM->getNamebyKoords($rout['toWhere']);
                if ($timeOut < (max($scanBattleMax, $crontime) + $sensedelta) * 60 && empty($CM->ud['planets'][$planetName]['norefuge'])) {
                    echo "\nEvacuation procedure activated .... ";
                    //эвакуация с атакуемой планеты
                    $fleetData = $CM->evacuation($rout['toWhere']);
                    if (!empty($fleetData)) {
                        echo "successed with data:\n";
                        print_r($fleetData);

                        //добавить код флота 
                        if (is_array($CM->oas['escapefleets'][$rout['id']])) {
                            $CM->oas['escapefleets'][$rout['id']][] = $fleetData;
                        } else {
                            $CM->oas['escapefleets'][$rout['id']] = array($fleetData);
                        }
                        
                        //отправка оповещения, что флоты успешно отправлены
                        $CM->mailReport('Fleets saved !',
                                'Fleet ID-' . $fleetData['id'] . ' has been sent from planet ' . $fleetData['from'] 
                                . ' to planet ' . $fleetData['to']
                                . ' at ' .  date('H:i:s') . '.');
                    } else {
                        $CM->mailReport('Fleets salvation is failed !',
                            'Some errors occured during salvation operation. Fleet has not been saved.');
                        echo "failed !";
                    }
                }
            }
    }

    echo "\nEvac fleets:";
    print_r($CM->oas['escapefleets']);
    
    //проверим нет ли атак, которые противник отменил или атак, которые уже состоялись
    //TO DO : надо проверять, есть ли угроза планете куда вернутся беженцы
    foreach($CM->oas['escapefleets'] as $k => $v) {
        //если в данный момент атаки от которой мы спасались нету - то надо вернуть беженцев назад
        if (empty($currentAttacks[$k])) {
            echo "\nUndo evacuation ... ";
            foreach ($v as $No => $fleetRefuge) {
                //время в пути
                $inWay = $CM->currentTime - $fleetRefuge['timeStart'];
                //если время возврата прошло - продолжаем путь - иначе на обратке перехватят
                if ($inWay > ($noReturnTime + $sensedelta) * 60) {
                    echo " returning time out!";
                    continue;
                }
                //продолжим путь, если известно, что при возврате попадем под атаку другого флота
                foreach ($routs as $rout) 
                    //маршрут из числа аттак на планету от куда беженцы и пападает в цикл хрона после возврата
                    if (!empty($currentAttacks[$rout['id']])
                        && $rout['toWherePlanet'] == $fleetRefuge['from']
                        && $rout['aTime'] + $sensedelta * 60  > $CM->currentTime + $inWay 
                        && $rout['aTime'] - $sensedelta * 60 < $CM->currentTime + $inWay + $scanBattleMax * 60) {
                            echo " too dangerous to return !";
                            continue 2;
                        }
                //отмена бегства - корабли возвращаются назад
                echo " successed !";
                $CM->abortMission($fleetRefuge['id']);
                //отправка оповещения, что флоты успешно развернуты назад в строну планеты
                $CM->mailReport('Fleet sent back', "Fleet {$fleetRefuge['id']} sent back to planet {$fleetRefuge['to']}!");

                unset($CM->oas['escapefleets'][$k][$No]);
            }
        }
        //нет связанных с маршрутом беженцев - убрать запись
        if (empty($CM->oas['escapefleets'][$k])) unset($CM->oas['escapefleets'][$k]);
    }
    //сохранение флотов и обнаруженных аттак до следующей итерации
    $CM ->setOGV('escapefleets', $CM->oas['escapefleets']);
    $CM ->setOGV('attacks', $currentAttacks);
    //определение времени следующей проверки
    if ($CM->isAlert && $timeOutMin < ($scanMax + $sensedelta) * 60) {
        $nxtScan = time() + (rand($scanBattleMin, $scanBattleMax) - $sensedelta) * 60;
    } else {
        $nxtScan = time() + (rand($scanMin, $scanMax) - $sensedelta) * 60;
    }
    $CM ->setOGV('nextscan', $nxtScan);
} else {

/* управление */
    if (!empty($_GET['turnback'])) {
        foreach ($CM->oas['escapefleets'] as $k => $cicle) 
            foreach ($cicle as $k2 => $evf) 
                if ($_GET['turnback'] == $evf['id']) {
                    $CM->http = new s_http();
                    $CM->http->init();
                    $CM->ready = $CM->auth();
                    if ($CM->ready) {
                        $CM->abortMission($evf['id']);
                        unset($CM->oas['escapefleets'][$k][$k2]);
                        echo "<div class=\"error\">Эвакуационный флот отправлен назад !</div>";
                    }
                    break 2;
                }
    }

    if (empty($_POST['mark'])) $mark = ''; else $mark = $_POST['mark']; 
    switch($mark) {
    case 'setoff':
        $CM ->setOGV('guardmode', 0);
        break;
    case 'seton':
        $CM ->setOGV('guardmode', 1);
        break;
    case 'clearlog':
        $CM ->setOGV('logs', array());
        break;
    case 'speedup':
        $CM ->setOGV('nextscan', time() - $sensedelta * 60);
        break;
    case 'evacuate':
        $CM->http = new s_http();
        $CM->http->init();
        $CM->ready = $CM->auth();
        if ($CM->ready) {
            echo "<p><b>Процедура эвакуации флота запущена:</b></p><pre>";
            $fleetCode = $CM->evacuation($_POST['koords']);
            echo "</pre>";
            if (!$fleetCode) {
                echo "<div class=\"error\">Эвакуация не проведена ! Либо некуда эвакуировать, либо на планете нет кораблей. Возможно проблема с соединением с сервером.</div>";
            } else {
                echo "<div class=\"error\">Эвакуационный флот отправлен (код - {$fleetCode['id']})! 
                    Внимание, в списке маршрутов флот появится только после очередного запуска няньки.</div>";
            }
        }        
        break;
    }

    if ($CM->oas['guardmode']) {
        echo "
        <form method=\"POST\">
            <font color=green><b>Режим охраны включен ! </b></font>
            <input type=\"submit\" value=\"Отключить...\">
            <input type=\"hidden\" name=\"mark\" value=\"setoff\">
        </form>";
    } else {
        echo "
        <form method=\"POST\">
            <font color=red><b>Режим охраны ВЫключен ! </b></font>
            <input type=\"submit\" value=\"Скорее включить...\">
            <input type=\"hidden\" name=\"mark\" value=\"seton\">
        </form>";
    }
    echo "<h1>Текущее состояние Няньки</h1>";
    
    if ($CM->ud['time']['tickerMethod'] == 'cron') {
        if ($CM->oas['nextscan'] - time() > 0) {
            echo "Время следующего сканирования ожидается через - " . ($CM->oas['nextscan'] - time()) . ' сек. в ' . date('d-m H:i', $CM->oas['nextscan']) . '.';
            echo "
        <form method=\"POST\">
            <input type=\"submit\" value=\"Ускорить!\">
            <input type=\"hidden\" name=\"mark\" value=\"speedup\">
        </form>";
        } else {
            echo "Время следующего сканирования ожидается при следующем запуске няньки (не позднее чем через {$CM->ud['time']['crontime']} мин.)";
        }
    }

    //создать таймер на js
    if ($CM->oas['guardmode'] && $tickerMethod == 'localjs') {
        if ($CM->oas['treat'] || !empty($CM->oas['escapefleets'])) {
            $fulltime = rand($scanBattleMin * 60, $scanBattleMax * 60) - $sensedelta * 60;
        } else {
            $fulltime = rand($scanMin * 60, $scanMax * 60) - $sensedelta * 60;
        }    
?>
    <script language="javascript">
        var fulltime = <?=$fulltime?>;
        var locationIn = document.location.href;
        var a = null;
        function tickTo() {
            fulltime--;
            if (fulltime < 0) {
                a = window.open("index.php?auto=1");
                window.focus();
                a.close();
                fulltime = 15;
                setTimeout("tickOut();", 1000);
            } else {
                setTimeout('tickTo();', 1000);
                var obj = document.getElementById("timing");
                obj.innerHTML = 'Следующий запуск проверки через ' + fulltime + ' сек';
            }
        }
        
        function tickOut() {
            fulltime--;
            if (fulltime < 0) {
                document.location.href = locationIn;
            } else {
                var obj = document.getElementById("timing");
                obj.innerHTML = 'Обновление страницы произодет через ' + fulltime + ' сек';
                setTimeout("tickOut();", 1000);
            }
        }
        
        setTimeout("tickTo();", 1000);
    </script>
    <div id="timing">Следующий запуск проверки через <?=$fulltime?> сек</div><a href="#" onclick="javascript: fulltime = 5;">Сбросить таймер до 5 сек..</a>
<?
    }
    
    echo "<table><tr><th>Флот</th><th>Миссия</th><th>Маршрут</th></tr>";
    
    foreach ($CM->ud['planets'] as $k => $v) {
        $threatSign = false;
        
        //проверка угроз вторжения
        foreach ($CM->oas['attacks'] as $atv) 
            if ($atv['toWherePlanet'] == $k) { $threatSign = true; break; }
        
        echo "
            <tr><th colspan=2 class=\"error\">$k " . ($threatSign ? 'угроза вторжения' : ''). "</th>
                <th>
                    <form method=\"POST\">
                        <input type=\"submit\" value=\"Эвакуация\">
                        <input type=\"hidden\" name=\"mark\" value=\"evacuate\">
                        <input type=\"hidden\" name=\"koords\" value=\"$v[0]\">
                    </form>
                </th>
            </tr>";
        //список маршрутов
        if (!empty($CM->oas['routs'])) {
            foreach ($CM->oas['routs'] as $rout) 
                if ($rout['toWhere'] == $v[0] || $rout['fromWhere'] == $v[0]) {
                    echo "<tr><td>{$rout['descr']}</td><td>{$rout['mission']}</td><td>{$rout['fromWhere']} -> {$rout['toWhere']}</td></tr>";    
                }
        }
        
        //список флотов эвакуации
        foreach ($CM->oas['escapefleets'] as $cicle) {
            foreach ($cicle as $evf) 
                if ($evf['from'] == $k)
                    echo "<tr><td colspan=3>Эвакуация на {$evf['to']} <a href=\"?turnback={$evf['id']}\">вернуть на планету</a></td></tr>";
        }
        
    }
    echo "</table>";
        
    
/*    <br />Текущее состояние:<pre><b>Список атак:</b>\n";
    print_r($CM->oas['attacks']);
    echo "<b>Список флотов в эвакуации:</b>\n";
    print_r($CM->oas['escapefleets']);
  */  
    echo "
        <form method=\"POST\">
            <input type=\"submit\" value=\"Очистить журнал\">
            <input type=\"hidden\" name=\"mark\" value=\"clearlog\">
        </form>";
    
    echo '<b>Журнал:</b>
        <table border=1 cellspacing=0 cellpadding=3>
        <tr><th width="100">Время</th><th width="150">Тема</th><th>Сообщение</th></tr>
    ';
    
    $logs = $CM->oas['logs'];
    while($row = array_pop($logs)) {
        echo '<tr><td>' . date('m/d H:i', $row['time']) . '</td><td>' . $row['subj'] . '</td><td>' . $row['body'] . '</td></tr>';
    }
    echo '</table>';
}

//сохранение установок
$st = new settings();
$st->S = $CM->oas;
$st->store();

?>

<div class="credits">
    Нянька для Ogame - ваш спокойный сон уже сегодня. <a href="http://shra.ru/category/gamer/ogame/">Сделано shra.</a> V.03 (2010)
</div>

</body>
</html>