<?php
    
	class Searcher {

        var $pos = 0;
        var $rangeEnd = 0;
        var $data = '';
		/***
		 * 
		 */
		function init($data) {
            $this->data = $data;
            $this->pos = 0;
        }
        function cursorTo($s, $toTail = true) {
            $newpos = stripos($this->data, $s, $this->pos);
            if ($newpos === false) return false;
            $this->pos = $newpos + ($toTail ? strlen($s) : 0);
            
            return true;
        }
        function setRangeEnd($s) {
            if (is_array($s)) {
                foreach ($s as $v) {
                    $newpos = stripos($this->data, $v, $this->pos);
                    if ($newpos === false) continue;
                    $this->rangeEnd = $newpos;
                    return true;
                }
                return false;
            } else {
                $newpos = stripos($this->data, $s, $this->pos);
                if ($newpos === false) return false;
                $this->rangeEnd = $newpos;
                return true;
            }
        }
        //          Range
        function getByPatternRange($pattern) {
            $s = $this->copyRange();
            if (preg_match($pattern, $s, $m)) 
                return $m[1];
            return false;
        }        
        //          Range
        function getByPatternFromRange($s1, $s2, $pattern) {
            $s = $this->readBeforeRange($s1, $s2);
            if (preg_match($pattern, $s, $m)) 
                return $m[1];
            return false;
        }
        
        //        pos  rangeEnd
        function readBeforeRange($s1, $s2) {
            $p1 = stripos($this->data, $s1, $this->pos);
            if ($p1 >= $this->rangeEnd || $p1 === false) return false;
            $p2 = stripos($this->data, $s2, $p1);
            if ($p2 === false || $p1 + strlen($s1) > $p2 || $p2 >= $this->rangeEnd) return false;

            $p1 += strlen($s1);
            return substr($this->data, $p1, $p2 - $p1);
        }
        
        //    
        function copyRange() {
            return substr($this->data, $this->pos,  $this->rangeEnd - $this->pos);
        }
        
        //      
        function isInRange($s) {
            $newpos = stripos($this->data, $s, $this->pos);
            if ($newpos === false || $newpos >= $this->rangeEnd) return false;
            return true;
        }
    }